drop table T_ITEM;
drop table T_CATEGORY;
drop table T_ACCOUNT;
drop table T_CUSTOMER;
drop table T_ORDER;
drop table T_PRODUCT;
drop table T_ORDER_ITEM;

create table T_ITEM (
   itemId VARCHAR(10) not null,
   description VARCHAR(255),
   imagePath VARCHAR(255),
   listPrice DOUBLE PRECISION,
   product_fk VARCHAR(10),
   unitCost DOUBLE PRECISION,
   primary key (itemId)
);

create table T_CATEGORY (
   categoryId VARCHAR(10) not null,
   description VARCHAR(255),
   name VARCHAR(50),
   primary key (categoryId)
);

create table T_ACCOUNT (
   userId VARCHAR(10) not null,
   pwd VARCHAR(10) not null,
   primary key (userId)
);

create table T_CUSTOMER (
	userId			varchar(12)		NOT NULL, 
	name			varchar(20)		NOT NULL,
	email			varchar(50),
	phoneno			varchar(15),
	zipcode			varchar(7),
	address			varchar(100),
   	creditCardExpiryDate VARCHAR(14),
   	creditCardNumber VARCHAR(25),
   	creditCardType VARCHAR(25),
    primary key (userId)
);

create table T_ORDER (
   orderId BIGINT not null,
   address VARCHAR(100),
   zipcode VARCHAR(10),
   creditCardExpiryDate VARCHAR(10),
   creditCardNumber VARCHAR(25),
   creditCardType VARCHAR(25),
   customer_fk VARCHAR(10),
   orderDate VARCHAR(14),   
   status VARCHAR(10),
   primary key (orderId)
);

create table T_PRODUCT (
   productId VARCHAR(10) not null,
   description VARCHAR(255),
   name VARCHAR(50),
   category_fk VARCHAR(10),
   primary key (productId)
);
create table T_ORDER_ITEM (
   orderItemId BIGINT not null,
   item_fk VARCHAR(10),
   quantity INTEGER,
   unitPrice DOUBLE PRECISION,
   order_fk BIGINT,
   primary key (orderItemId)
);

alter table T_ITEM add index (product_fk), add constraint FK94B4401E687CCA15 foreign key (product_fk) references T_PRODUCT (productId);
create index IX94B4401E687CCA15 on T_ITEM (product_fk);
alter table T_ORDER add index (customer_fk), add constraint FK227638396607CC6 foreign key (customer_fk) references T_CUSTOMER (userId);
alter table T_PRODUCT add index (category_fk), add constraint FK4B5D6BE45BA8ABA6 foreign key (category_fk) references T_CATEGORY (categoryId);
create index IX4B5D6BE45BA8ABA6 on T_PRODUCT (category_fk);
alter table T_ORDER_ITEM add index (item_fk), add constraint FK12E6824F7E22B971 foreign key (item_fk) references T_ITEM (itemId);
alter table T_ORDER_ITEM add index (order_fk), add constraint FK12E6824F4991FF56 foreign key (order_fk) references T_ORDER (orderId);
create index IX12E6824F4991FF56 on T_ORDER_ITEM (order_fk);
