package net.javajigi.abs;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.*;

import net.javajigi.db.ConnectionManager;

public class ExampleCreate {
	Random rnd = null;
	
	public ExampleCreate() {
		rnd = new Random();
	}
	
	public Integer getScheduleCode(){
		Integer result3 = null;
		while(true){
			long result = (rnd.nextLong()) % 1000000;
			long result2 = Math.abs(result);
			if ( result2 > 100000 ){
				return  new Integer((new Long(result2)).intValue());
			}
		}
	}
	
	public int getKoreanAirplaneCode(){
		int code[] = {1101, 1103, 1105, 1107, 1109, 1111, 1113, 1115, 1117, 1119,
			1121, 1123, 1125, 1127, 1129};
		return code[rnd.nextInt(15)];
	}	

	public int getAsianaAirplaneCode(){
		int code[] = {8801, 8803, 8805, 8807, 8809, 8811, 8813, 8815, 8817, 8819,
			8821, 8823, 8825, 8827, 8829};
		return code[rnd.nextInt(15)];
	}

	public int getStartHour() {
		return rnd.nextInt(14);
	}

	public int getStartMinute() {
		return rnd.nextInt(6);
	}

	public String getHour(int i){
		String startTime[] = 
			{"07", "08", "09", "10", "11", "12", "13", "14", 
			"15", "16", "17", "18", "19", "20", "21"};
		return startTime[i];		
	}

	public String getMinute(int i){
		String startMinute[] = 
			{"00", "10", "20", "30", "40", "50"}; 		

		return startMinute[i];		
	}

	public String getStartTime(int hour, int minute){
		return getHour(hour) + getMinute(minute);
	}	

	public String getEndTime(int hour, int minute) {
		return getHour(hour) + getMinute(minute);
	}
	
	public String getCity(int i){
		String city[] = 
			{"", "λ", "뱸", ""};

		return city[i];
	}
	
	public String getStartCity() {
		return getCity(rnd.nextInt(4));
	}	

	public String getWeekDay() {
		String city[] = 
			{"SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"};
		
		
		return city[rnd.nextInt(7)];
	}
	
	public String getAirLine() {
		String airLine[] = {"װ", "ƽþƳ"};
		
		return airLine[rnd.nextInt(2)];
	}	

	public String getEndCity(String startCity) {
		while ( true ){
			String endCity = getCity(rnd.nextInt(4));
			
			if ( !startCity.equals(endCity) ){
				return endCity;
			}
		}
	}	
	
	
	public static void main(String[] args) {
		ExampleCreate create = new ExampleCreate();		

		try {
			String query = 
				"insert into schedulecode values " +
				"(?, ?, ?, ?, ?, ?, ?, ?)";
			
			Connection con = ConnectionManager.getConnection();
			PreparedStatement pstmt = con.prepareStatement(query);
			
			Set codes = new HashSet();
			
			for(int i=0; i < 2000; i++ ){
				codes.add(create.getScheduleCode());
			}
			
			int result = 0;
			
			Iterator codeIter = codes.iterator();
			
			while ( codeIter.hasNext()){
				Integer code = (Integer)codeIter.next();
				
				int hour = create.getStartHour();
				int minute = create.getStartMinute();
				String startCity = create.getStartCity();
				pstmt.setInt(1, code.intValue());
				pstmt.setString(2, create.getWeekDay());
				pstmt.setString(3, startCity);
				pstmt.setString(4, create.getStartTime(hour, minute));
				pstmt.setString(5, create.getEndCity(startCity));
				pstmt.setString(6, create.getStartTime(hour+1, minute));
				
				String airLine = create.getAirLine();				
				pstmt.setString(7, airLine);
				
				if ( airLine.equals("װ")){
					pstmt.setInt(8, create.getKoreanAirplaneCode());
				} else {
					pstmt.setInt(8, create.getAsianaAirplaneCode());
				}				
				
				result += pstmt.executeUpdate();				
			}
			
			System.out.println("Result : " + result);
			
			pstmt.close();
			con.close();			
		} catch ( SQLException e ){
			System.out.println("Exception is created : " + e.getMessage());
		}		
	}

}
