package net.javajigi.action;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.form.BoardForm;
import net.javajigi.model.Board;
import net.javajigi.model.BoardFile;
import net.javajigi.model.BoardManager;
import net.javajigi.util.FileUploadUtil;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;
import org.apache.struts.upload.FormFile;

/**
 * Xdoclet  ±
 * @struts.action
 *      name="boardForm"
 *      parameter="method"
 *      path="/board"
 *      scope="request"
 *      validate="true"
 *
 * @struts.action-forward
 *      name="list"
 *      path="/board_list.do"
 *      redirect="true"
 */
public class BoardAction extends DispatchAction {
	public ActionForward create(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		Board board = processBoard(form);

		BoardManager manager = BoardManager.instance();
		manager.create(board);

		return mapping.findForward("list");
	}

	public ActionForward update(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		Board board = processBoard(form);

		BoardManager manager = BoardManager.instance();
		manager.update(board);
		
		return mapping.findForward("list");	
	}

	private Board processBoard(ActionForm form)
		throws
			IllegalAccessException,
			InvocationTargetException,
			NoSuchMethodException,
			FileNotFoundException,
			IOException {
		BoardForm boardForm = (BoardForm) form;
		Board board = boardForm.getBoardValue();
		
		FormFile[] fileList = boardForm.getFileList();
		
		for (int i = 0; i < fileList.length; i++) {
			FormFile formFile = fileList[i];
			
			if ( formFile != null ){
				String fileName = formFile.getFileName();

				if ((fileName != null) && (!fileName.equals("")) ) {
					BoardFile boardFile = FileUploadUtil.doFileUpload(formFile);			
					board.addBoardFile(boardFile);
				}				
			}
		}
		
		return board;
	}

	public ActionForward remove(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		BoardForm boardForm = (BoardForm)form;
		int boardNo = boardForm.getBoardValue().getBoardNo();

		BoardManager manager = BoardManager.instance();
		manager.remove(boardNo);

		return mapping.findForward("list");
	}
}
