package net.javajigi.chapter3.servlet;

import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @web.servlet name="HelloWorldServlet" 
 * 				display-name="HelloWorld Servlet" 
 * 
 * @web.servlet-init-param 	name="name" 
 * 							value="${hello.servlet.name}"
 * 
 * @web.servlet-mapping url-pattern="/HelloWorld/*"
 * @web.servlet-mapping url-pattern="*.HelloWorld"
 * @web.servlet-mapping url-pattern="/HelloWorldServlet"
 */
public class HelloWorldServlet extends HttpServlet {

	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {
		process(request, response);
	}

	protected void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {
		process(request, response);
	}

	protected void process(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {
		ServletConfig config = this.getServletConfig();
		String name = config.getInitParameter("name");

		response.setContentType("text/html");
		java.io.PrintWriter out = response.getWriter();
		out.println("<html>");
		out.println("<head>");
		out.println("<title>HelloWorld Servlet</title>");
		out.println("</head>");
		out.println("<body>");
		out.println("<h1>Hi!! " + name + ". Hello World!!</h1>");
		out.println("</body>");
		out.println("</html>");
		out.close();
	}
}
