package net.javajigi.chapter3.taglib;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * @jsp.tag name="helloWorld"
 */
public class HelloWorldTag extends TagSupport {
	private String name = null;

	public int doStartTag() throws JspException {
		try {
			JspWriter out = pageContext.getOut();

			out.println("Hi!! " + name + ". Hello World!!");
		} catch (IOException e) {
			throw new JspException(e.getMessage());
		}

		return SKIP_BODY;
	}

	/**
	 * @jsp.attribute	required="true" 
	 *                  rtexprvalue="true"
	 *                  description="User Name"
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param string 
	 */
	public void setName(String name) {
		this.name = name;
	}

}
