package net.javajigi.model;

import java.util.ArrayList;
import java.util.List;

import net.javajigi.util.DateTime;

public class Board {
	private int boardNo = 0;
	private String title = null;
	private String name = null;
	private String email = null;
	private String password = null;
	private String createDate = null;
	private String content = null;
	private int hitCount = 0;
	private List files = null;
	
	public Board() {
		files = new ArrayList();
	}
	
	public void addBoardFile(BoardFile boardFile){
		boardFile.setBoard(this);
		files.add(boardFile);
	}
	
	public List getBoardFiles (){
		return files;
	}

	public int getBoardNo() {
		return boardNo;
	}

	public String getContent() {
		return content;
	}

	public String getCreateDate() {
		return createDate;
	}

	public String getParseCreateDate() {
		return DateTime.getParseDateString(getCreateDate(), "-");
	}

	public String getEmail() {
		return email;
	}

	public int getHitCount() {
		return hitCount;
	}

	public String getName() {
		return name;
	}

	public String getPassword() {
		return password;
	}

	public String getTitle() {
		return title;
	}

	public void setBoardNo(int i) {
		boardNo = i;
	}

	public void setContent(String string) {
		content = string;
	}

	public void setCreateDate(String string) {
		createDate = string;
	}

	public void setEmail(String string) {
		email = string;
	}

	public void setHitCount(int i) {
		hitCount = i;
	}

	public void setName(String string) {
		name = string;
	}

	public void setPassword(String string) {
		password = string;
	}

	public void setTitle(String string) {
		title = string;
	}
}
