package net.javajigi.petstore.model;

import java.util.ArrayList;
import java.util.Iterator;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import edu.arbor.util.plugin.HibernatePlugIn;

import net.javajigi.petstore.model.domain.Category;
import net.javajigi.petstore.model.domain.Item;
import net.javajigi.petstore.model.domain.Product;
import net.javajigi.petstore.util.Page;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Query;
import net.sf.hibernate.Session;

public class PetStoreDAO   {
	private Log log = LogFactory.getLog(PetStoreDAO.class);

	public Category findCategory(String categoryId)
		throws HibernateException {
		try {
			Session session = HibernatePlugIn.openSession();
			
			Category category = (Category)session.load(Category.class, categoryId);
			
			/*
			 * Since category.product is lazy loaded,
			 * traverse the collection to load all the product to display
			 */
			Iterator it = category.getProducts(  ).iterator(  );

			while ( it.hasNext(  ) )
			{
				Product p = ( Product ) it.next(  );
				p.getName(  );
			}

			return category;
		} catch (HibernateException e) {
			log.error(" Error retrieving object", e);
			throw e;
		} finally {
			HibernatePlugIn.closeSession();
		}
	}

	public Product findProduct(String productId)
		throws HibernateException {
		try {
			Session session = HibernatePlugIn.openSession();
			
			Product product = (Product)session.load(Product.class, productId);
			
			/*
			 * Since category.product is lazy loaded,
			 * traverse the collection to load all the product to display
			 */
			Iterator it = product.getItems(  ).iterator(  );

			while ( it.hasNext(  ) )
			{
				Item i = ( Item ) it.next(  );
				i.getDescription(  );
			}

			return product;
		} catch (HibernateException e) {
			log.error(" Error retrieving object", e);
			throw e;
		} finally {
			HibernatePlugIn.closeSession();
		}
	}

	public Page searchProduct(String keyword, int start, int count)
		throws HibernateException {
		try {
			Session session = HibernatePlugIn.openSession();
			String oql =
				"FROM p IN CLASS "
					+ Product.class
					+ " WHERE"
					+ " ( p.productId LIKE '%"
					+ keyword
					+ "%' ) OR"
					+ " ( p.name LIKE '%"
					+ keyword
					+ "%' ) OR"
					+ " ( p.description LIKE '%"
					+ keyword
					+ "%' )";

			Query query = session.createQuery(oql);

			return toPage(query, start, count);
		} catch (HibernateException e) {
			log.error(" Error retrieving object", e);
			throw e;
		} finally {
			HibernatePlugIn.closeSession();
		}
	}

	private Page toPage(Query query, int start, int count)
		throws HibernateException {

		int i = 0;
		int imax = start + count;
		ArrayList lst = new ArrayList();

		for (Iterator it = query.iterate(); it.hasNext();) {
			if ((i >= start) && (i < imax)) {
				lst.add(it.next());
			}

			i++;
		}

		return new Page(lst, start, (start + count) < i);
	}

}