package net.javajigi.user;

import java.sql.SQLException;
import java.util.List;

/**
 *   API ϴ ڵ  ϰ Ǵ Ŭ.
 * UserDAO ̿Ͽ ͺ̽   ۾ ϵ ϸ,
 * ͺ̽ ͵ ̿Ͽ Ͻ  ϴ  Ѵ.
 * Ͻ   쿡 Ͻ  ϴ Ŭ 
 *    ִ.
 */
public class UserManager {
	private UserManager() {
	}

	public static UserManager instance() {
		return (new UserManager());
	}

	public int create(User user) throws SQLException, ExistedUserException {
		if (getUserDAO().existedUser(user.getUserId())) {
			throw new ExistedUserException(user.getUserId() + " ϴ ̵Դϴ.");
		}

		return getUserDAO().create(user);
	}

	public int update(User user) throws SQLException {
		return getUserDAO().update(user);
	}	

	public int remove(String userId) throws SQLException {
		return getUserDAO().remove(userId);
	}

	public User findUser(String userId)
		throws SQLException, UserNotFoundException {
		User user = getUserDAO().findUser(userId);
		
		if (user == null) {
			throw new UserNotFoundException(userId + "  ʴ ̵Դϴ.");
		}
		
		return user;
	}

	public List findUserList(int currentPage, int countPerPage)
		throws SQLException {
		return getUserDAO().findUserList(currentPage, countPerPage);
	}

	public boolean login(String userId, String password)
		throws SQLException, UserNotFoundException, PasswordMismatchException {
		User user = findUser(userId);

		if (!user.isMatchPassword(password)) {
			throw new PasswordMismatchException("йȣ ġ ʽϴ.");
		}

		return true;
	}

	private UserDAO getUserDAO() {
		return new UserDAO();
	}
}
