package net.javajigi.user.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.javajigi.abs.Constants;
import net.javajigi.user.form.LoginForm;
import net.javajigi.user.model.PasswordMismatchException;
import net.javajigi.user.model.User;
import net.javajigi.user.model.UserManager;
import net.javajigi.user.model.UserNotFoundException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 *      name="loginForm"
 *      path="/login"
 *      input="/login.jsp"
 *      scope="request"
 *      validate="true"
 *
 * @struts.action-forward
 *      name="user_list"
 *      path="/user_list.do"
 * 		redirect="true"
 */
public class LoginAction extends Action {
	private Log log = LogFactory.getLog(net.javajigi.user.action.LoginAction.class);

	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		LoginForm loginForm = (LoginForm) form;
		ActionErrors errors = new ActionErrors();
		
		try {
			//𵨿 α ó .
			UserManager manager = UserManager.instance();
			manager.login(loginForm.getUserId(), loginForm.getPassword());

			User user = manager.findUser(loginForm.getUserId());
	
			//ǿ User ü .
			HttpSession session = request.getSession();
			session.setAttribute(Constants.USER_KEY, user);
			if (log.isInfoEnabled()) {	
				log.info(
					"User '"
						+ user.getUserId()
						+ "' logged on in session "
						+ session.getId());
			}
		} catch (UserNotFoundException e) {
			errors.add(
				ActionErrors.GLOBAL_ERROR,
				new ActionError("error.user.notfound",loginForm.getUserId()));
		} catch (PasswordMismatchException e) {
			errors.add(
				ActionErrors.GLOBAL_ERROR,
				new ActionError("error.password.mismatch"));
		}
		
		if (!errors.isEmpty()) {
			saveErrors(request, errors);
			return (mapping.getInputForward());
		}

		String forwardURL = "/switch.do?prefix=&page=/index.do";			
		//̵  .
		return new ActionForward(forwardURL, true);			
		
	}

}
