package net.javajigi.user.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.abs.action.SignonAction;
import net.javajigi.user.form.UserForm;
import net.javajigi.user.model.User;
import net.javajigi.user.model.UserManager;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 *      name="userForm"
 *      path="/user_modify"
 *      input="/user_modify.jsp"
 *      scope="request"
 *      validate="true"
 *
 * @struts.action-forward
 *      name="user_list"
 *      path="/user_list.do"
 * 		redirect="true"
 */
public class UpdateAction extends SignonAction {
	private Log log = LogFactory.getLog(net.javajigi.user.action.UpdateAction.class);

	public ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		UserForm userForm = (UserForm) form;
	
		User user = new User();
		PropertyUtils.copyProperties(user, userForm);

		UserManager manager = UserManager.instance();
		manager.update(user);

		if (log.isInfoEnabled()) {	
			log.info(
				"User '"
					+ user.getUserId()
					+ "' updated ");
		}
			
		return mapping.findForward("user_list");
	}
}
