package net.javajigi.user.form;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

/** 
 * XDoclet definition:
 * @struts:form name="userForm"
 */
public class UserForm extends ValidatorForm {
	private String password = null;
	private String userId = null;
	private String email = null;
	private String name = null;
	private String phoneNo1 = null;
	private String phoneNo2 = null;
	private String phoneNo3 = null;
	private String zipCode = null;
	private String address = null;

	public void reset(ActionMapping mapping, HttpServletRequest request) {
		password = null;
		userId = null;
		email = null;
		name = null;
		phoneNo1 = null;
		phoneNo2 = null;
		phoneNo3 = null;
		zipCode = null;
		address = null;
	}

	public String getAddress() {
		return address;
	}

	public String getEmail() {
		return email;
	}

	public String getName() {
		return name;
	}

	public String getPassword() {
		return password;
	}

	public String getPhoneNo1() {
		return phoneNo1;
	}

	public String getPhoneNo2() {
		return phoneNo2;
	}

	public String getPhoneNo3() {
		return phoneNo3;
	}

	public String getUserId() {
		return userId;
	}

	public String getZipCode() {
		return zipCode;
	}

	public void setAddress(String string) {
		address = string;
	}

	/**
	 * @struts.validator type="email" 		
	 */
	public void setEmail(String string) {
		email = string;
	}

	/**
	 * @struts.validator type="required"
	 */
	public void setName(String string) {
		name = string;
	}

	/**
	 * @struts.validator type="required"
	 */
	public void setPassword(String string) {
		password = string;
	}

	public void setPhoneNo1(String string) {
		phoneNo1 = string;
	}

	public void setPhoneNo2(String string) {
		phoneNo2 = string;
	}

	public void setPhoneNo3(String string) {
		phoneNo3 = string;
	}

	/**
	 * @struts.validator type="required"
	 * 		msgkey="message.userid"
	 */
	public void setUserId(String string) {
		userId = string;
	}

	/**
	 * @struts.validator type="mask"
	 * 		msgkey="message.zipcode" 
	 * @struts.validator-var name="mask"
	 * 		value="${zipcode}"
	 */
	public void setZipCode(String string) {
		zipCode = string;
	}

}
